// PPRAM: Parallel Port Writable RAM
module PPRAM(CLK, D, PDS, PWE, PINT, PSEL, RST, LSEL, LED);
input CLK;
input [7:0] D;
input PDS;
input PWE;
input PINT;
input PSEL;
input RST;
input [2:0] LSEL;
output [7:0] LED;

// Eight registers and an address to remember which to write to next
reg [7:0] mem [0:7];
reg [2:0] memAddr;
reg lastPDS;

// Either output lights and an address to selector which memory to display
reg [7:0] LED;

// Clock based logic
always @(posedge CLK) begin
    // Initializes the RAM
    if (RST || PINT) begin
        memAddr <= 'h0;
        mem[0] <= 'hFF;
        mem[1] <= 'hFF;
        mem[2] <= 'hFF;
        mem[3] <= 'hFF;
        mem[4] <= 'hFF;
        mem[5] <= 'hFF;
        mem[6] <= 'hFF;
        mem[7] <= 'hFF;
    end
    else if (PWE && PDS) begin // SOMETHING IS WRONG HERE
        mem[memAddr] <= D;
    	if (~lastPDS) memAddr <= memAddr + 'h1;
    end
    else if (~PWE) memAddr <= 'h0;

    // Display the memory
    if (PSEL) begin
        LED[7] <= 'h0;
        LED[6:4] <= LSEL;
        LED[3] <= 'h0;
        LED[2:0] <= memAddr;
    end
    else LED <= mem[LSEL];
    
    // Remember the current state for triggers
    lastPDS <= PDS;
end

endmodule

