module DP8RAM(CLK, D, W, WBADDR, RBADDR, BYTE, RWADDR, WORD);
input CLK;
input [7:0] D;
input W;
input [2:0] WBADDR;
input [2:0] RBADDR;
output [7:0] BYTE;
input [1:0] RWADDR;
output [15:0] WORD;

// Eight byte registers
reg [7:0] mem [0:7];

// Byte and Long outputs
reg [7:0] BYTE;
reg [16:0] WORD;

// Clock based logic
always @(posedge CLK) begin
    // Store the specified byte
    if (W) mem[WBADDR] <= D;

    // Output the specified byte, specified wordm, and a long
    BYTE <= mem[RBADDR];
    case (RWADDR)
      0: WORD <= { mem[1], mem[0] };
      1: WORD <= { mem[3], mem[2] };
      2: WORD <= { mem[5], mem[4] };
      3: WORD <= { mem[7], mem[6] };
    endcase
end

endmodule
