module LEDx4(CLK, IN, OUT, LED0, LED1, LED2, LED3);

input CLK;
input [15:0] IN;
output [3:0] OUT;
output LED0, LED1, LED2, LED3;

reg [3:0] OUT;
reg LED0, LED1, LED2, LED3;
reg [7:0] cycle;

always @(posedge CLK) begin
    case (cycle[7:6])
      0: begin OUT <= IN[15:12]; LED0 <= 0; LED1 <= 1; LED2 <= 0; LED3 <= 0; end
      1: begin OUT <= IN[11:8];  LED0 <= 1; LED1 <= 0; LED2 <= 0; LED3 <= 0; end
      2: begin OUT <= IN[7:4];   LED0 <= 0; LED1 <= 0; LED2 <= 0; LED3 <= 1; end
      3: begin OUT <= IN[3:0];   LED0 <= 0; LED1 <= 0; LED2 <= 1; LED3 <= 0; end
    endcase
    
    cycle <= cycle + 1;
end
endmodule 
