module PPADDR(CLK, WE, W, ADDR, AE);
input CLK;
input WE;
input W;
output [2:0] ADDR;
output AE;

reg [2:0] ADDR;
reg AE;
reg lastW;

// Clock based logic
always @(posedge CLK) begin
    // Reset the addres when Write Enable is low
    if (~WE) begin
        ADDR <= 'hF;
        lastW <= 'h0;
    end
    // Next address
    else begin
        if (W & ~lastW) ADDR <= ADDR + 'h1;
        lastW <= W;
    end
    
    // Set address enable
    AE <= WE & W;
end
endmodule
